#!/usr/bin/python3
import at
# test handling of embedded corrector

import at

import matplotlib as mp

D1 = at.Drift('DR01', 3.0)
QF = at.Quadrupole('QF', 1.0, 0.2)
D2 = D1
D2.FamName = 'DR02'
D2.Length = 2
QD = at.deepcopy(QF)
QD.FamName = 'QD'
QD.K = -0.4
C = at.Corrector('CHV',0.1,[0 , 0])
M = at.Marker('Marker')

fodocell = [QF, D1, QD, C, D2, M, D2, C, QF]
cells = [fodocell, fodocell, fodocell, fodocell, fodocell,
           fodocell, fodocell, fodocell, fodocell, fodocell]
ring = at.Lattice(cells,energy=1e9)

#ring[3] = at.Corrector('C',0.1,[-0.00002, 0.00001])
refpts = range(len(ring) + 1)
ring.radiation_off()
elemdata0, tune, chrom, elemdata=at.linopt4(ring,0.0001,list(refpts))
s_pos = elemdata['s_pos']
closed_orbit_x=elemdata['closed_orbit'][:,0]
closed_orbit_xp=elemdata['closed_orbit'][:,1]
closed_orbit_y=elemdata['closed_orbit'][:,2]
closed_orbit_yp=elemdata['closed_orbit'][:,3]

mp.figure()
mp.plot(s_pos,closed_orbit_x,closed_orbit_y)
mp.xlabel('s [m]')
mp.ylabel('m')
mp.title('orb_x' )
mp.show()
